


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/examples/ntlmrelayx/clients/mssqlrelayclient.py: 23%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/examples/ntlmrelayx/clients/mssqlrelayclient.py</b> :
            <span class="pc_cov">23%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            98 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">26 run</span>
            <span class="mis shortkey_m button_toggle_mis">72 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">0 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="pln"><a href="#n18">18</a></p>
<p id="n19" class="stm run hide_run"><a href="#n19">19</a></p>
<p id="n20" class="stm run hide_run"><a href="#n20">20</a></p>
<p id="n21" class="stm run hide_run"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="stm run hide_run"><a href="#n25">25</a></p>
<p id="n26" class="pln"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="pln"><a href="#n30">30</a></p>
<p id="n31" class="stm run hide_run"><a href="#n31">31</a></p>
<p id="n32" class="stm run hide_run"><a href="#n32">32</a></p>
<p id="n33" class="stm mis"><a href="#n33">33</a></p>
<p id="n34" class="stm mis"><a href="#n34">34</a></p>
<p id="n35" class="pln"><a href="#n35">35</a></p>
<p id="n36" class="stm run hide_run"><a href="#n36">36</a></p>
<p id="n37" class="pln"><a href="#n37">37</a></p>
<p id="n38" class="stm run hide_run"><a href="#n38">38</a></p>
<p id="n39" class="stm run hide_run"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="stm mis"><a href="#n41">41</a></p>
<p id="n42" class="stm mis"><a href="#n42">42</a></p>
<p id="n43" class="pln"><a href="#n43">43</a></p>
<p id="n44" class="stm run hide_run"><a href="#n44">44</a></p>
<p id="n45" class="stm mis"><a href="#n45">45</a></p>
<p id="n46" class="pln"><a href="#n46">46</a></p>
<p id="n47" class="stm mis"><a href="#n47">47</a></p>
<p id="n48" class="stm mis"><a href="#n48">48</a></p>
<p id="n49" class="stm mis"><a href="#n49">49</a></p>
<p id="n50" class="pln"><a href="#n50">50</a></p>
<p id="n51" class="pln"><a href="#n51">51</a></p>
<p id="n52" class="stm mis"><a href="#n52">52</a></p>
<p id="n53" class="stm mis"><a href="#n53">53</a></p>
<p id="n54" class="stm mis"><a href="#n54">54</a></p>
<p id="n55" class="stm mis"><a href="#n55">55</a></p>
<p id="n56" class="stm mis"><a href="#n56">56</a></p>
<p id="n57" class="stm mis"><a href="#n57">57</a></p>
<p id="n58" class="stm mis"><a href="#n58">58</a></p>
<p id="n59" class="stm mis"><a href="#n59">59</a></p>
<p id="n60" class="stm mis"><a href="#n60">60</a></p>
<p id="n61" class="stm mis"><a href="#n61">61</a></p>
<p id="n62" class="stm mis"><a href="#n62">62</a></p>
<p id="n63" class="stm mis"><a href="#n63">63</a></p>
<p id="n64" class="pln"><a href="#n64">64</a></p>
<p id="n65" class="stm mis"><a href="#n65">65</a></p>
<p id="n66" class="pln"><a href="#n66">66</a></p>
<p id="n67" class="pln"><a href="#n67">67</a></p>
<p id="n68" class="pln"><a href="#n68">68</a></p>
<p id="n69" class="stm mis"><a href="#n69">69</a></p>
<p id="n70" class="stm mis"><a href="#n70">70</a></p>
<p id="n71" class="stm mis"><a href="#n71">71</a></p>
<p id="n72" class="stm mis"><a href="#n72">72</a></p>
<p id="n73" class="pln"><a href="#n73">73</a></p>
<p id="n74" class="stm run hide_run"><a href="#n74">74</a></p>
<p id="n75" class="pln"><a href="#n75">75</a></p>
<p id="n76" class="stm mis"><a href="#n76">76</a></p>
<p id="n77" class="pln"><a href="#n77">77</a></p>
<p id="n78" class="stm mis"><a href="#n78">78</a></p>
<p id="n79" class="stm mis"><a href="#n79">79</a></p>
<p id="n80" class="stm mis"><a href="#n80">80</a></p>
<p id="n81" class="stm mis"><a href="#n81">81</a></p>
<p id="n82" class="stm mis"><a href="#n82">82</a></p>
<p id="n83" class="stm mis"><a href="#n83">83</a></p>
<p id="n84" class="stm mis"><a href="#n84">84</a></p>
<p id="n85" class="pln"><a href="#n85">85</a></p>
<p id="n86" class="pln"><a href="#n86">86</a></p>
<p id="n87" class="stm mis"><a href="#n87">87</a></p>
<p id="n88" class="stm mis"><a href="#n88">88</a></p>
<p id="n89" class="pln"><a href="#n89">89</a></p>
<p id="n90" class="pln"><a href="#n90">90</a></p>
<p id="n91" class="stm mis"><a href="#n91">91</a></p>
<p id="n92" class="pln"><a href="#n92">92</a></p>
<p id="n93" class="pln"><a href="#n93">93</a></p>
<p id="n94" class="pln"><a href="#n94">94</a></p>
<p id="n95" class="stm mis"><a href="#n95">95</a></p>
<p id="n96" class="stm mis"><a href="#n96">96</a></p>
<p id="n97" class="pln"><a href="#n97">97</a></p>
<p id="n98" class="stm mis"><a href="#n98">98</a></p>
<p id="n99" class="stm mis"><a href="#n99">99</a></p>
<p id="n100" class="pln"><a href="#n100">100</a></p>
<p id="n101" class="stm mis"><a href="#n101">101</a></p>
<p id="n102" class="stm mis"><a href="#n102">102</a></p>
<p id="n103" class="pln"><a href="#n103">103</a></p>
<p id="n104" class="pln"><a href="#n104">104</a></p>
<p id="n105" class="stm mis"><a href="#n105">105</a></p>
<p id="n106" class="pln"><a href="#n106">106</a></p>
<p id="n107" class="stm run hide_run"><a href="#n107">107</a></p>
<p id="n108" class="stm mis"><a href="#n108">108</a></p>
<p id="n109" class="stm mis"><a href="#n109">109</a></p>
<p id="n110" class="stm mis"><a href="#n110">110</a></p>
<p id="n111" class="pln"><a href="#n111">111</a></p>
<p id="n112" class="stm mis"><a href="#n112">112</a></p>
<p id="n113" class="pln"><a href="#n113">113</a></p>
<p id="n114" class="stm mis"><a href="#n114">114</a></p>
<p id="n115" class="stm mis"><a href="#n115">115</a></p>
<p id="n116" class="stm mis"><a href="#n116">116</a></p>
<p id="n117" class="stm mis"><a href="#n117">117</a></p>
<p id="n118" class="pln"><a href="#n118">118</a></p>
<p id="n119" class="pln"><a href="#n119">119</a></p>
<p id="n120" class="stm mis"><a href="#n120">120</a></p>
<p id="n121" class="stm mis"><a href="#n121">121</a></p>
<p id="n122" class="pln"><a href="#n122">122</a></p>
<p id="n123" class="stm mis"><a href="#n123">123</a></p>
<p id="n124" class="stm mis"><a href="#n124">124</a></p>
<p id="n125" class="pln"><a href="#n125">125</a></p>
<p id="n126" class="stm run hide_run"><a href="#n126">126</a></p>
<p id="n127" class="stm mis"><a href="#n127">127</a></p>
<p id="n128" class="pln"><a href="#n128">128</a></p>
<p id="n129" class="pln"><a href="#n129">129</a></p>
<p id="n130" class="stm run hide_run"><a href="#n130">130</a></p>
<p id="n131" class="stm run hide_run"><a href="#n131">131</a></p>
<p id="n132" class="pln"><a href="#n132">132</a></p>
<p id="n133" class="stm run hide_run"><a href="#n133">133</a></p>
<p id="n134" class="stm mis"><a href="#n134">134</a></p>
<p id="n135" class="stm mis"><a href="#n135">135</a></p>
<p id="n136" class="pln"><a href="#n136">136</a></p>
<p id="n137" class="stm mis"><a href="#n137">137</a></p>
<p id="n138" class="stm mis"><a href="#n138">138</a></p>
<p id="n139" class="stm mis"><a href="#n139">139</a></p>
<p id="n140" class="pln"><a href="#n140">140</a></p>
<p id="n141" class="stm run hide_run"><a href="#n141">141</a></p>
<p id="n142" class="stm mis"><a href="#n142">142</a></p>
<p id="n143" class="stm mis"><a href="#n143">143</a></p>
<p id="n144" class="stm mis"><a href="#n144">144</a></p>
<p id="n145" class="pln"><a href="#n145">145</a></p>
<p id="n146" class="stm run hide_run"><a href="#n146">146</a></p>
<p id="n147" class="pln"><a href="#n147">147</a></p>
<p id="n148" class="stm mis"><a href="#n148">148</a></p>
<p id="n149" class="pln"><a href="#n149">149</a></p>
<p id="n150" class="stm run hide_run"><a href="#n150">150</a></p>
<p id="n151" class="stm mis"><a href="#n151">151</a></p>
<p id="n152" class="stm mis"><a href="#n152">152</a></p>
<p id="n153" class="stm mis"><a href="#n153">153</a></p>
<p id="n154" class="pln"><a href="#n154">154</a></p>
<p id="n155" class="stm run hide_run"><a href="#n155">155</a></p>
<p id="n156" class="stm mis"><a href="#n156">156</a></p>
<p id="n157" class="pln"><a href="#n157">157</a></p>
<p id="n158" class="stm run hide_run"><a href="#n158">158</a></p>
<p id="n159" class="stm mis"><a href="#n159">159</a></p>
<p id="n160" class="stm mis"><a href="#n160">160</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># MSSQL (TDS) Protocol Client</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># Author:</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#   Alberto Solino (@agsolino)</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#   Dirk-jan Mollema / Fox-IT (https://www.fox-it.com)</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com"># MSSQL client for relaying NTLMSSP authentication to MSSQL servers</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="com"># ToDo:</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="com"># [ ] Handle SQL Authentication</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="stm run hide_run"><span class="key">import</span> <span class="nam">random</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm run hide_run"><span class="key">import</span> <span class="nam">string</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm run hide_run"><span class="key">from</span> <span class="nam">struct</span> <span class="key">import</span> <span class="nam">unpack</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">LOG</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">examples</span><span class="op">.</span><span class="nam">ntlmrelayx</span><span class="op">.</span><span class="nam">clients</span> <span class="key">import</span> <span class="nam">ProtocolClient</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">tds</span> <span class="key">import</span> <span class="nam">MSSQL</span><span class="op">,</span> <span class="nam">DummyPrint</span><span class="op">,</span> <span class="nam">TDS_ENCRYPT_REQ</span><span class="op">,</span> <span class="nam">TDS_ENCRYPT_OFF</span><span class="op">,</span> <span class="nam">TDS_PRE_LOGIN</span><span class="op">,</span> <span class="nam">TDS_LOGIN</span><span class="op">,</span> <span class="nam">TDS_INIT_LANG_FATAL</span><span class="op">,</span> <span class="xx">\</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="pln">    <span class="nam">TDS_ODBC_ON</span><span class="op">,</span> <span class="nam">TDS_INTEGRATED_SECURITY_ON</span><span class="op">,</span> <span class="nam">TDS_LOGIN7</span><span class="op">,</span> <span class="nam">TDS_SSPI</span><span class="op">,</span> <span class="nam">TDS_LOGINACK_TOKEN</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">ntlm</span> <span class="key">import</span> <span class="nam">NTLMAuthChallenge</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">nt_errors</span> <span class="key">import</span> <span class="nam">STATUS_SUCCESS</span><span class="op">,</span> <span class="nam">STATUS_ACCESS_DENIED</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">spnego</span> <span class="key">import</span> <span class="nam">SPNEGO_NegTokenResp</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm run hide_run"><span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm run hide_run">    <span class="key">from</span> <span class="nam">OpenSSL</span> <span class="key">import</span> <span class="nam">SSL</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm mis"><span class="key">except</span> <span class="nam">Exception</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm mis">    <span class="nam">LOG</span><span class="op">.</span><span class="nam">critical</span><span class="op">(</span><span class="str">"pyOpenSSL is not installed, can't continue"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm run hide_run"><span class="nam">PROTOCOL_CLIENT_CLASS</span> <span class="op">=</span> <span class="str">"MSSQLRelayClient"</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm run hide_run"><span class="key">class</span> <span class="nam">MYMSSQL</span><span class="op">(</span><span class="nam">MSSQL</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">address</span><span class="op">,</span> <span class="nam">port</span><span class="op">=</span><span class="num">1433</span><span class="op">,</span> <span class="nam">rowsPrinter</span><span class="op">=</span><span class="nam">DummyPrint</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">        <span class="nam">MSSQL</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span><span class="nam">address</span><span class="op">,</span> <span class="nam">port</span><span class="op">,</span> <span class="nam">rowsPrinter</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">resp</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">sessionData</span> <span class="op">=</span> <span class="op">{</span><span class="op">}</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm run hide_run">    <span class="key">def</span> <span class="nam">initConnection</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">connect</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="pln">        <span class="com">#This is copied from tds.py</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm mis">        <span class="nam">resp</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">preLogin</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm mis">        <span class="key">if</span> <span class="nam">resp</span><span class="op">[</span><span class="str">'Encryption'</span><span class="op">]</span> <span class="op">==</span> <span class="nam">TDS_ENCRYPT_REQ</span> <span class="key">or</span> <span class="nam">resp</span><span class="op">[</span><span class="str">'Encryption'</span><span class="op">]</span> <span class="op">==</span> <span class="nam">TDS_ENCRYPT_OFF</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"Encryption required, switching to TLS"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t51" class="pln">            <span class="com"># Switching to TLS now</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="stm mis">            <span class="nam">ctx</span> <span class="op">=</span> <span class="nam">SSL</span><span class="op">.</span><span class="nam">Context</span><span class="op">(</span><span class="nam">SSL</span><span class="op">.</span><span class="nam">TLSv1_METHOD</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm mis">            <span class="nam">ctx</span><span class="op">.</span><span class="nam">set_cipher_list</span><span class="op">(</span><span class="str">'RC4, AES256'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm mis">            <span class="nam">tls</span> <span class="op">=</span> <span class="nam">SSL</span><span class="op">.</span><span class="nam">Connection</span><span class="op">(</span><span class="nam">ctx</span><span class="op">,</span><span class="key">None</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="stm mis">            <span class="nam">tls</span><span class="op">.</span><span class="nam">set_connect_state</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="stm mis">            <span class="key">while</span> <span class="key">True</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="stm mis">                <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm mis">                    <span class="nam">tls</span><span class="op">.</span><span class="nam">do_handshake</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm mis">                <span class="key">except</span> <span class="nam">SSL</span><span class="op">.</span><span class="nam">WantReadError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="stm mis">                    <span class="nam">data</span> <span class="op">=</span> <span class="nam">tls</span><span class="op">.</span><span class="nam">bio_read</span><span class="op">(</span><span class="num">4096</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="stm mis">                    <span class="nam">self</span><span class="op">.</span><span class="nam">sendTDS</span><span class="op">(</span><span class="nam">TDS_PRE_LOGIN</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span><span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="stm mis">                    <span class="nam">tds</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">recvTDS</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm mis">                    <span class="nam">tls</span><span class="op">.</span><span class="nam">bio_write</span><span class="op">(</span><span class="nam">tds</span><span class="op">[</span><span class="str">'Data'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="pln">                <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="stm mis">                    <span class="key">break</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t67" class="pln">            <span class="com"># SSL and TLS limitation: Secure Socket Layer (SSL) and its replacement,</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="pln">            <span class="com"># Transport Layer Security(TLS), limit data fragments to 16k in size.</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span> <span class="op">=</span> <span class="num">16</span><span class="op">*</span><span class="num">1024</span><span class="op">-</span><span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">tlsSocket</span> <span class="op">=</span> <span class="nam">tls</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">resp</span> <span class="op">=</span> <span class="nam">resp</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="stm mis">        <span class="key">return</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t74" class="stm run hide_run">    <span class="key">def</span> <span class="nam">sendNegotiate</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span><span class="nam">negotiateMessage</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="pln">        <span class="com">#Also partly copied from tds.py</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="stm mis">        <span class="nam">login</span> <span class="op">=</span> <span class="nam">TDS_LOGIN</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t78" class="stm mis">        <span class="nam">login</span><span class="op">[</span><span class="str">'HostName'</span><span class="op">]</span> <span class="op">=</span> <span class="op">(</span><span class="str">''</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="op">[</span><span class="nam">random</span><span class="op">.</span><span class="nam">choice</span><span class="op">(</span><span class="nam">string</span><span class="op">.</span><span class="nam">ascii_letters</span><span class="op">)</span> <span class="key">for</span> <span class="nam">_</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="num">8</span><span class="op">)</span><span class="op">]</span><span class="op">)</span><span class="op">)</span><span class="op">.</span><span class="nam">encode</span><span class="op">(</span><span class="str">'utf-16le'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="stm mis">        <span class="nam">login</span><span class="op">[</span><span class="str">'AppName'</span><span class="op">]</span>  <span class="op">=</span> <span class="op">(</span><span class="str">''</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="op">[</span><span class="nam">random</span><span class="op">.</span><span class="nam">choice</span><span class="op">(</span><span class="nam">string</span><span class="op">.</span><span class="nam">ascii_letters</span><span class="op">)</span> <span class="key">for</span> <span class="nam">_</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="num">8</span><span class="op">)</span><span class="op">]</span><span class="op">)</span><span class="op">)</span><span class="op">.</span><span class="nam">encode</span><span class="op">(</span><span class="str">'utf-16le'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="stm mis">        <span class="nam">login</span><span class="op">[</span><span class="str">'ServerName'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">server</span><span class="op">.</span><span class="nam">encode</span><span class="op">(</span><span class="str">'utf-16le'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="stm mis">        <span class="nam">login</span><span class="op">[</span><span class="str">'CltIntName'</span><span class="op">]</span>  <span class="op">=</span> <span class="nam">login</span><span class="op">[</span><span class="str">'AppName'</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="stm mis">        <span class="nam">login</span><span class="op">[</span><span class="str">'ClientPID'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">random</span><span class="op">.</span><span class="nam">randint</span><span class="op">(</span><span class="num">0</span><span class="op">,</span><span class="num">1024</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="stm mis">        <span class="nam">login</span><span class="op">[</span><span class="str">'PacketSize'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="stm mis">        <span class="nam">login</span><span class="op">[</span><span class="str">'OptionFlags2'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">TDS_INIT_LANG_FATAL</span> <span class="op">|</span> <span class="nam">TDS_ODBC_ON</span> <span class="op">|</span> <span class="nam">TDS_INTEGRATED_SECURITY_ON</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t86" class="pln">        <span class="com"># NTLMSSP Negotiate</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="stm mis">        <span class="nam">login</span><span class="op">[</span><span class="str">'SSPI'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">negotiateMessage</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="stm mis">        <span class="nam">login</span><span class="op">[</span><span class="str">'Length'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">login</span><span class="op">.</span><span class="nam">getData</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t90" class="pln">        <span class="com"># Send the NTLMSSP Negotiate</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">sendTDS</span><span class="op">(</span><span class="nam">TDS_LOGIN7</span><span class="op">,</span> <span class="nam">login</span><span class="op">.</span><span class="nam">getData</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t93" class="pln">        <span class="com"># According to the specs, if encryption is not required, we must encrypt just</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="pln">        <span class="com"># the first Login packet :-o</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="stm mis">        <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">resp</span><span class="op">[</span><span class="str">'Encryption'</span><span class="op">]</span> <span class="op">==</span> <span class="nam">TDS_ENCRYPT_OFF</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">tlsSocket</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t97" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t98" class="stm mis">        <span class="nam">tds</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">recvTDS</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">sessionData</span><span class="op">[</span><span class="str">'NTLM_CHALLENGE'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">tds</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t101" class="stm mis">        <span class="nam">challenge</span> <span class="op">=</span> <span class="nam">NTLMAuthChallenge</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="stm mis">        <span class="nam">challenge</span><span class="op">.</span><span class="nam">fromString</span><span class="op">(</span><span class="nam">tds</span><span class="op">[</span><span class="str">'Data'</span><span class="op">]</span><span class="op">[</span><span class="num">3</span><span class="op">:</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="pln">        <span class="com">#challenge.dump()</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t105" class="stm mis">        <span class="key">return</span> <span class="nam">challenge</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t107" class="stm run hide_run">    <span class="key">def</span> <span class="nam">sendAuth</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span><span class="nam">authenticateMessageBlob</span><span class="op">,</span> <span class="nam">serverChallenge</span><span class="op">=</span><span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t108" class="stm mis">        <span class="key">if</span> <span class="nam">unpack</span><span class="op">(</span><span class="str">'B'</span><span class="op">,</span> <span class="nam">authenticateMessageBlob</span><span class="op">[</span><span class="op">:</span><span class="num">1</span><span class="op">]</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span> <span class="op">==</span> <span class="nam">SPNEGO_NegTokenResp</span><span class="op">.</span><span class="nam">SPNEGO_NEG_TOKEN_RESP</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="stm mis">            <span class="nam">respToken2</span> <span class="op">=</span> <span class="nam">SPNEGO_NegTokenResp</span><span class="op">(</span><span class="nam">authenticateMessageBlob</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="stm mis">            <span class="nam">token</span> <span class="op">=</span> <span class="nam">respToken2</span><span class="op">[</span><span class="str">'ResponseToken'</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="stm mis">            <span class="nam">token</span> <span class="op">=</span> <span class="nam">authenticateMessageBlob</span><span class="strut">&nbsp;</span></p>
<p id="t113" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t114" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">sendTDS</span><span class="op">(</span><span class="nam">TDS_SSPI</span><span class="op">,</span> <span class="nam">token</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="stm mis">        <span class="nam">tds</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">recvTDS</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t116" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">replies</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">parseReply</span><span class="op">(</span><span class="nam">tds</span><span class="op">[</span><span class="str">'Data'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t117" class="stm mis">        <span class="key">if</span> <span class="nam">TDS_LOGINACK_TOKEN</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">replies</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="pln">            <span class="com">#Once we are here, there is a full connection and we can</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="pln">            <span class="com">#do whatever the current user has rights to do</span><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">sessionData</span><span class="op">[</span><span class="str">'AUTH_ANSWER'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">tds</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="stm mis">            <span class="key">return</span> <span class="key">None</span><span class="op">,</span> <span class="nam">STATUS_SUCCESS</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t123" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">printReplies</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="stm mis">            <span class="key">return</span> <span class="key">None</span><span class="op">,</span> <span class="nam">STATUS_ACCESS_DENIED</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t126" class="stm run hide_run">    <span class="key">def</span> <span class="nam">close</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="stm mis">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">disconnect</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t128" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t129" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t130" class="stm run hide_run"><span class="key">class</span> <span class="nam">MSSQLRelayClient</span><span class="op">(</span><span class="nam">ProtocolClient</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t131" class="stm run hide_run">    <span class="nam">PLUGIN_NAME</span> <span class="op">=</span> <span class="str">"MSSQL"</span><span class="strut">&nbsp;</span></p>
<p id="t132" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t133" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">serverConfig</span><span class="op">,</span> <span class="nam">targetHost</span><span class="op">,</span> <span class="nam">targetPort</span> <span class="op">=</span> <span class="num">1433</span><span class="op">,</span> <span class="nam">extendedSecurity</span><span class="op">=</span><span class="key">True</span> <span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t134" class="stm mis">        <span class="nam">ProtocolClient</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">serverConfig</span><span class="op">,</span> <span class="nam">targetHost</span><span class="op">,</span> <span class="nam">targetPort</span><span class="op">,</span> <span class="nam">extendedSecurity</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t135" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">extendedSecurity</span> <span class="op">=</span> <span class="nam">extendedSecurity</span><span class="strut">&nbsp;</span></p>
<p id="t136" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t137" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">domainIp</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t138" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">machineAccount</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t139" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">machineHashes</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t140" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t141" class="stm run hide_run">    <span class="key">def</span> <span class="nam">initConnection</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t142" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">session</span> <span class="op">=</span> <span class="nam">MYMSSQL</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">targetHost</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetPort</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t143" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">initConnection</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t144" class="stm mis">        <span class="key">return</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t145" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t146" class="stm run hide_run">    <span class="key">def</span> <span class="nam">keepAlive</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t147" class="pln">        <span class="com"># Don't know yet what needs to be done for TDS</span><span class="strut">&nbsp;</span></p>
<p id="t148" class="stm mis">        <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t149" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t150" class="stm run hide_run">    <span class="key">def</span> <span class="nam">killConnection</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t151" class="stm mis">        <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">session</span> <span class="key">is</span> <span class="key">not</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t152" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">disconnect</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t153" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">session</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t154" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t155" class="stm run hide_run">    <span class="key">def</span> <span class="nam">sendNegotiate</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">negotiateMessage</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t156" class="stm mis">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">sendNegotiate</span><span class="op">(</span><span class="nam">negotiateMessage</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t157" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t158" class="stm run hide_run">    <span class="key">def</span> <span class="nam">sendAuth</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">authenticateMessageBlob</span><span class="op">,</span> <span class="nam">serverChallenge</span><span class="op">=</span><span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t159" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">sessionData</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">sessionData</span><span class="strut">&nbsp;</span></p>
<p id="t160" class="stm mis">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">sendAuth</span><span class="op">(</span><span class="nam">authenticateMessageBlob</span><span class="op">,</span> <span class="nam">serverChallenge</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
